//
//  ELViewController.m
//  MKOverlayBugHarness
//
//  Created by Pedr Browne on 25/11/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "MKOverlayBugHarnessViewController.h"

@implementation MKOverlayBugHarnessViewController

@synthesize mapView = mapView_;
@synthesize locationManager = locationManger_;

-(id)initWithCoder:(NSCoder *)aDecoder
{
    self.locationManager = [[CLLocationManager alloc] init];
    self.locationManager.desiredAccuracy = kCLLocationAccuracyBest;
    self.locationManager.distanceFilter = 10;
    self.locationManager.headingFilter = 5; 
    return [super initWithCoder:aDecoder];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    self.mapView.showsUserLocation = YES;
    self.mapView.userInteractionEnabled = YES;
    self.mapView.userTrackingMode = MKUserTrackingModeFollowWithHeading;
    self.mapView.delegate = self;
    self.locationManager.delegate = self;
    [self.locationManager startUpdatingHeading];
    [self.locationManager startUpdatingLocation];
}

-(void)addOverlays
{
    CLLocation *currentLocation = self.mapView.userLocation.location;
    
     for(int i = 0; i < 50; i++)
     {
        MKCircle *circle = [MKCircle circleWithCenterCoordinate:currentLocation.coordinate radius:50];
        [self.mapView addOverlay:circle];
     }
}

//------------------------------------------------------------------------------
//  MKMapViewDelegate
//------------------------------------------------------------------------------ 


-(MKOverlayView *)mapView:(MKMapView *)mapView viewForOverlay:(id < MKOverlay>)overlay
{
     MKCircleView *circleView = [[MKCircleView alloc] initWithCircle:(MKCircle *)overlay];
     circleView.fillColor = [UIColor greenColor];
     circleView.alpha = 0.1;
     circleView.strokeColor = [UIColor greenColor];
     circleView.lineWidth = 1;
     return circleView;
}

//------------------------------------------------------------------------------
//  CLLocationManagerDelegate
//------------------------------------------------------------------------------ 

- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation
{
    [self addOverlays];
    NSLog(@"Total Overlays = %i", [self.mapView.overlays count]);
}

@end
